function coplot_steps_revision(varargin)
%Function that plots and evaluates almost everything for the 'limping
%paper'

if nargin == 0
    %folder = '/Users/willistepp/Pictures/post_Analysis/171006_H11_S20/';
    %folder = '/Users/willistepp/Pictures/post_Analysis/171025_triple_stage/';
    %folder = '/Users/willistepp/Pictures/post_Analysis/171230_H_11_S_20/';
    %folder = '/Users/willistepp/Pictures/post_Analysis/180130_stage_steps/';
    %folder = '/Users/willistepp/Pictures/post_Analysis/180620_JF_11_20/';
    %folder = '/Users/willistepp/Pictures/post_Analysis/180620_color_swap/';
    %folder = '/Users/willistepp/Pictures/post_Analysis/180810_JF1120/';
    %folder = '/Users/willistepp/Pictures/post_Analysis/180810_color_swap/';
    folder = 'C:\Data_Analysed\180821_JF1120_8\';
    %folder = 'C:\Data_Analysed\180821_JF1120_9\';
    %folder = 'C:\Data_Analysed\180921_11wt20EE_11\';

    folder = 'C:\Data_Analysed\181228_wt_13\';

    %folder = 'C:\Data_Analysed\scrap_9\';
    
    %folder = 'C:\Data_Analysed\190812_sh_19\';
elseif nargin == 1
    folder = varargin{1};
end

%% Presets

%SET number of colors that have been analyzed
num_colors = 2;
min_num_steps = 8;
plot_segments = 0;
plot_runs = 0;
plot_backsteps = 0;
nm_per_px = 93;
small_step = 11; %nm
big_step = 15; %nm
short_step = 1; %frames smaller or equal
long_step = 2; %frames bigger or equal


% set default plot properties
background_color = [1 1 1];% [33,42,52]/255;  
text_color = [ 0 0 0]; %[0.7,0.7,0.7]; %0.7 equals 179
set(groot,'defaultFigureColor',background_color);

set(groot,'defaultAxesColor','none');
set(groot,'defaultAxesXColor',text_color);set(groot,'defaultAxesYColor',text_color);set(groot,'defaultAxesZColor',text_color);
set(groot,'defaultAxesColorOrder',text_color);set(groot,'defaultLineLineWidth',4);
set(groot,'defaultFigureInvertHardcopy','off');set(groot,'defaultAxesFontSize',20);set(groot,'defaultTextFontSize',12);




if num_colors == 2
    %colors = {[138,20,84]/255;[0,108,32]/255}; %177,221,255
    colors = {[238,92,108]/255;[136,176,75]/255}; % Pantone Greenery
    plot_offset = 0;
else
    colors = {[86,143,205]/255;[123,163,82]/255;[202,104,77]/255};
    plot_offset = 0.5;
end





cycle_time = 0.404;
%folder = 'C:\Data_Analysed\180821_swap_8\';


% set domain name from folder name
if str2num(folder(end-1)) == 9 %|| strcmp(folder(end-2:end-1),'11') == 1
    domain_646 = '11'; domain_549 = '20';
elseif str2num(folder(end-1)) == 8 || str2num(folder(end-1)) == 7 || strcmp(folder(end-2:end-1),'11') == 1 || strcmp(folder(end-2:end-1),'13') == 1
    domain_646 = '20'; domain_549 = '11';
else
    domain_646 = '646'; domain_549 = '549';
end

%% Data import
dirs = dir(folder);
names = {dirs.name};
names = names(3:end);
k = 1;
% get data out of the folders and place into cell structure combining
for i = 1:numel(names)
    l = mod(i-1,num_colors)+1;
    data = load([folder names{i} '\data.mat'],'data');
    data = data.data;
    
    steps{k}.orig_data{l} = data.runs{data.run_num,1}(6,:);
    steps{k}.detected{l} = data.steps.detected(:,:);
    %get step positions
    steps{k}.positions{l} = get_step_positions(steps{k}.detected{l},l);
    steps{k}.com{l} = step_fit_2d(data);
    steps{k}.dir{l} = step_directions([folder names{i} '\']);
    steps{k}.sizes{l} = get_step_sizes(steps{k}.detected{l});
    %increment k if new set of data
    if mod(i,num_colors) == 0; k = k+1;end
end
   
clear k

p_range = 1:numel(steps);

%% Plot full runs colocalized
if num_colors == 2 && plot_runs == 1
   for k = 1:numel(steps)
       figure
       ax = axes;
       plot(steps{k}.orig_data{1},'Color',colors{1},'LineWidth',1)
       hold on
       plot(steps{k}.detected{1},'Color',colors{1})
       plot(steps{k}.orig_data{2},'Color',colors{2},'LineWidth',1)
       plot(steps{k}.detected{2},'Color',colors{2})
       ax.XLabel.String = 'Time [frames]';
       ax.YLabel.String = 'Distance [px]';
       ax.Box = 'off';
   end

end
%% Detect alternating patterns of steps in channels 1 and 2 
...and count backstep frequency from full traces
% extract segments of the run that has a alternating pattern of at least 4
% steps

if num_colors == 2
for k = 1:numel(steps)
    %put all positions into one matrix. channel number added in the detect
    %positions subfunction. Add direction relative to the MT_axis to this
    %data
    positions = [[steps{k}.positions{1} , steps{k}.positions{2}];[steps{k}.dir{1} , steps{k}.dir{2}]];
    %sort all entries giving a list of channel steps in temporal order
    positions = sortrows(positions')';
    % Problem here is/was that if two values in the first row are the same,
    % they get ordered the way they appear in the list before. This changes
    % the situation if I swap the colors in the import.
    % 180813 trying solution where it is checked wether this happens and
    % then sort in a way that maximizes alternating stepping
    for q = 2:length(positions)-1
        
        % 3 7 10 15 15 18
        % 1 2 1  1  2  2
        % if situation above, swap the two position 15
        % Does this result in always the same array?
        % First tests show that ~2 percent difference.
       if positions(1,q) == positions(1,q+1) && positions(2,q-1) == positions(2,q)
           position_save = positions(:,q);
           positions(:,q) = positions(:,q+1);
           positions(:,q+1) = position_save;
       end
       

    end
    
    
    
    
    %check for alternating pattern in this list and write back data.
    start_pos = 1;
    start_m = 1;
    segment = 1;
    for m = 2:length(positions)
       if positions(2,m) ~= positions (2,m-1) || m == length(positions)
           if m == length(positions)
                end_pos = positions(1,m);
           else
                end_pos = positions(1,m+1)-1;
           end
       else
           if m - start_m > min_num_steps
               end_pos = min([length(steps{k}.detected{1}) length(steps{k}.detected{2}) end_pos]);
               steps{k}.extracted{segment} = [steps{k}.detected{1}(start_pos:end_pos);steps{k}.detected{2}(start_pos:end_pos);start_pos:end_pos];
               steps{k}.extracted_data{segment} = [steps{k}.orig_data{1}(start_pos:end_pos);steps{k}.orig_data{2}(start_pos:end_pos);start_pos:end_pos];    
               steps{k}.extracted_pos{segment} = positions(:,start_m+1:m-1);
               segment = segment + 1;
           end
           start_m = m-1;
           start_pos = positions(1,m-1);
       end
    end
    
    %calculate backstep frequency from the whole runs without alternating
    %pattern detection
    steps{k}.backstep_freq(1) = numel(steps{k}.sizes{1}(steps{k}.sizes{1} < 0))/numel(steps{k}.sizes{1});
    steps{k}.backstep_freq(2) = numel(steps{k}.sizes{2}(steps{k}.sizes{2} < 0))/numel(steps{k}.sizes{2});
end



% from these segments that have only alternating steps, calculate relativ
% stepping data
times1_2 = []; times2_1 = [];
sizes_1 = []; sizes_2 = [];
timed_sizes_1 = []; timed_sizes_2 = [];
after_small_steps_all = cell(1,2);
after_big_steps_all = cell(1,2);
big_steps_dir_all = cell(1,2);
small_steps_dir_all = cell(1,2);
steps_dir_all = cell(1,2);
all_sizes = [];


%%% CHOOSE DATA SET HERE
%p_range = [6]; %numel(steps) %1 and 3 looks good step size wise as of 171108

%%%


%% Calculate relevant data from alternating stepping sequences
for p = p_range %numel(steps)
    times{p}.times1_2 = []; times{p}.times2_1 = [];
    after_small_steps = cell(1,2); after_big_steps = cell(1,2);
    small_steps_dir = cell(1,2); big_steps_dir = cell(1,2); steps_dir = cell(1,2);
    if isfield(steps{p},'extracted_pos')
        for s = 1:numel(steps{p}.extracted_pos)
            positions = steps{p}.extracted_pos{s};
            
            %% get size data and in a second struct add the time it took
            %  in the second row for steps where possible (first is not)
            for color = 1:num_colors
                step_sizes{color} = diff(steps{p}.extracted{s}(color,:));
                step_sizes_for_timing{color} = step_sizes{color}(step_sizes{color} ~= 0);
                step_sizes{color} = step_sizes{color}(step_sizes{color} > 0);
                % check for initial step
                timings = diff(steps{p}.extracted_pos{s}(1,:));
                if steps{p}.extracted_pos{s}(2,1) == color
                    while length(step_sizes_for_timing{color}(2:end)) ~= length(timings(2:2:end))
                        step_sizes_for_timing{color} = step_sizes_for_timing{color}(2:end);
                    end
                    timed_sizes{color} = [step_sizes_for_timing{color}(2:end);timings(2:2:end)];
                else
                    while length(step_sizes_for_timing{color}(1:end)) ~= length(timings(1:2:end))
                        step_sizes_for_timing{color} = step_sizes_for_timing{color}(2:end);
                    end
                    timed_sizes{color} = [step_sizes_for_timing{color}(1:end);timings(1:2:end)];
                end   
            end

            sizes = {diff(steps{p}.extracted{s}(1,:)),diff(steps{p}.extracted{s}(2,:))};
            %%% paramteres of single runs
    
            %n = [step_sizes{1}]*93 < 11;
            
            disp(sprintf('movie %s segment %d size %f N = %d from %d to %d',names{p*2-1},s,mean([step_sizes{1}])*93,length([step_sizes{1}]),steps{p}.extracted{s}(3,1),steps{p}.extracted{s}(3,end)))
            disp(sprintf('movie %s segment %d size %f N = %d from %d to %d',names{p*2},s,mean([step_sizes{2}])*93,length([step_sizes{2}]),steps{p}.extracted{s}(3,1),steps{p}.extracted{s}(3,end)))
            %disp(num2str(sum(n)))
            %pool data
            sizes_1 = [sizes_1 diff(steps{p}.extracted{s}(1,:))];
            timed_sizes_1 = [timed_sizes_1 timed_sizes{1}];
            sizes_2 = [sizes_2 diff(steps{p}.extracted{s}(2,:))];
            timed_sizes_2 = [timed_sizes_2 timed_sizes{2}];
            all_sizes = [all_sizes [sizes{:}]];
            
            %% filter out big and small steps and look for the step sizes of
            % the next step in the other channel
            
            for k = 1:size(positions,2)-1
               if positions(3,k) <  small_step/93
                   after_small_steps{positions(2,k+1)}(end+1) = positions(3,k+1);
               elseif positions (3,k) > big_step/93
                   after_big_steps{positions(2,k+1)}(end+1) = positions(3,k+1);
               end
            end            
            after_small_steps_all{1} = [after_small_steps_all{1} after_small_steps{1}];
            after_small_steps_all{2} = [after_small_steps_all{2} after_small_steps{2}];
            after_big_steps_all{1} = [after_big_steps_all{1} after_big_steps{1}];
            after_big_steps_all{2} = [after_big_steps_all{2} after_big_steps{2}];            
            
            %% Get directions data depending on the size of the step
            for k = 1:size(positions,2)
                steps_dir{positions(2,k)}(end+1) = positions(4,k);
               if positions(3,k) < small_step/93
                   small_steps_dir{positions(2,k)}(end+1) = positions(4,k);
               elseif positions (3,k) > big_step/93
                   big_steps_dir{positions(2,k)}(end+1) = positions(4,k);                   
               end                
            end
            steps_dir_all{1} = [steps_dir_all{1} steps_dir{1}];
            steps_dir_all{2} = [steps_dir_all{2} steps_dir{2}];
            small_steps_dir_all{1} = [small_steps_dir_all{1} small_steps_dir{1}];
            small_steps_dir_all{2} = [small_steps_dir_all{2} small_steps_dir{2}];
            big_steps_dir_all{1} = [big_steps_dir_all{1} big_steps_dir{1}];
            big_steps_dir_all{2} = [big_steps_dir_all{2} big_steps_dir{2}]; 
            
            
            
            
            
            
            %% Get dwell time data
            time_diffs = diff(positions(1,:));
            if time_diffs(1) == 0
                time_diffs = time_diffs(2:end);
                positions = positions(:,2:end);
            end
            
            
            if positions(2,1) == 1
                times{p}.times1_2 = [times{p}.times1_2 time_diffs(1:2:length(time_diffs))];
                times{p}.times2_1 = [times{p}.times2_1 time_diffs(2:2:length(time_diffs))];
            else
                times{p}.times2_1 = [times{p}.times2_1 time_diffs(1:2:length(time_diffs))];
                times{p}.times1_2 = [times{p}.times1_2 time_diffs(2:2:length(time_diffs))];
            end
        end
        %pool data
        times1_2 = [times1_2 times{p}.times1_2];
        times2_1 = [times2_1 times{p}.times2_1];
         
    end
end


sizes_plot{1} = sizes_1(sizes_1 > 0)*93;
sizes_plot{2} = sizes_2(sizes_2 > 0)*93;
all_sizes = all_sizes(all_sizes > 0)*93;
times1_2 = times1_2*cycle_time;
times2_1 = times2_1*cycle_time;
bin_edges = cycle_time*0.99:cycle_time:10; % was 0.5:x:x

elseif num_colors == 3
    for p = p_range
    for color = 1:num_colors
        steps{p}.extracted{1}(color,:) = steps{p}.detected{color};
        steps{p}.extracted_data{1}(color,:) = steps{p}.orig_data{color};
        sizes{color} = diff([steps{p}.detected{color}]);
        sizes{color} = sizes{color}(sizes{color} > 0)*nm_per_px;
    end
    steps{p}.extracted{1}(4,:) = 1:size(steps{p}.extracted{1},2);
    steps{p}.extracted_data{1}(4,:) = 1:size(steps{p}.extracted{1},2);
    end
    all_sizes = [sizes{:}];
end
%% FIGURE predefine
% predefine so all figures can go into one docked figure
% set group docked below
desktop = com.mathworks.mde.desk.MLDesktop.getInstance;
desktop.closeGroup(['Coplot' folder])
desktop.closeGroup(['Dwell times' folder])
myGroup = desktop.addGroup(['Coplot' folder]);
figH_main    = gobjects(1, 8);

desktop.addGroup(['Dwell times' folder]);
figH_dwell    = gobjects(1, 4);

myGroup_neg = desktop.addGroup('Backsteps');
figH_neg    = gobjects(1, 9);


bakWarn = warning('off','MATLAB:HandleGraphics:ObsoletedProperty:JavaFrame');
set(groot,'defaultFigureWindowStyle','Docked');
%% FIGURES for dwell time size dependence

figure
timed_sizes_all = timed_sizes_1;

bin_edges_2 = 1:1:33;
slow_steps = timed_sizes_all(1,timed_sizes_all(2,:) >= long_step);
histogram(slow_steps(slow_steps > 0)*93,'BinEdges',bin_edges_2,'FaceColor',[0.2 0.2 0.2],'Normalization','probability')
hold on

fast_steps = timed_sizes_all(1,timed_sizes_all(2,:) <= short_step);
histogram(fast_steps(fast_steps > 0)*93,'BinEdges',bin_edges_2,'FaceColor',[0.8 0.8 0.8],'Normalization','probability')

figure
ax = axes;
times = 0:10;
for time = times
    step_sizes = timed_sizes_all(1,timed_sizes_all(2,:) == time)*93;
    mean_step_sizes(1,time+1) = mean(step_sizes(step_sizes > 0));
    mean_step_sizes(2,time+1) = std(step_sizes(step_sizes > 0));
    %sprintf('%i: %i',time,length(step_sizes(step_sizes > 0)))
    histogram(step_sizes(step_sizes > 0),20);
end

FIT = polyfitn(times,mean_step_sizes(1,:),1);
fit_parameter = FIT.Coefficients;
fit_y = times*fit_parameter(1) + fit_parameter(2);
scatter(times,mean_step_sizes(1,:));
hold on 
errorbar(times,mean_step_sizes(1,:),mean_step_sizes(2,:),'LineStyle','none');
plot(times,fit_y)
ax.XLabel.String = 'Dwell time [frames]';
ax.YLabel.String = 'Mean step size [\mum]';
ax.Title.String = strrep(strrep(folder(1:end-1),'\','\\'),'_','\_');
ax.XLim = [times(1)-0.5 times(end)+0.5]; 
ax.FontSize = 18;
%% FIGURE negative steps
if plot_backsteps == 1
    desktop.setGroupDocked('Backsteps', 0);
    pause(0.3)
    n = 1;
    for k = 1:numel(steps)
        sizes1 = diff(steps{k}.detected{1});
        neg_pos1 = sizes1 < 0;
        sizes2 = diff(steps{k}.detected{2});
        neg_pos2 = sizes2 < 0;
        neg_pos = round((neg_pos1 + neg_pos2)/2);

        segment = ones(1,10);
        segments = conv(neg_pos,segment,'same');
        if sum(segments) > 0
            neg_segment1.detected = steps{k}.detected{1}(segments == 1);
            neg_segment1.data = steps{k}.orig_data{1}(segments == 1);
            neg_segment2.detected = steps{k}.detected{2}(segments == 1);
            neg_segment2.data = steps{k}.orig_data{2}(segments == 1);
            figH_neg(n) = figure('Name',['Backstep ' num2str(n)],'NumberTitle','off');
                pause(0.1);  % Magic, reduces rendering errors
                set(get(handle(figH_neg(n)), 'javaframe'), 'GroupName','Backsteps');
            plot(neg_segment1.detected,'Color',colors{1},'LineWidth',3)
            hold on
            plot(neg_segment1.data,'Color',colors{1},'LineWidth',1)
            plot(neg_segment2.detected,'Color',colors{2},'LineWidth',3)
            plot(neg_segment2.data,'Color',colors{2},'LineWidth',1)
            hold off
            n = n+1;
            drawnow
        end


    end
end
%% FIGURE Single traces
if plot_segments == 1
    for p = p_range
        if isfield(steps{p},'extracted')
           for s = 1:numel(steps{p}.extracted)
           figure
           hold on
           %plot(steps{p}.detected{c},'Color',colors{c})
           %hold on
               for c = 1:num_colors
                plot(steps{p}.extracted{s}(num_colors+1,:),steps{p}.extracted{s}(c,:)+(c-1)*plot_offset-min(steps{p}.extracted{s}(c,:)),'Color',colors{c},'LineWidth',3)
                plot(steps{p}.extracted_data{s}(num_colors+1,:),steps{p}.extracted_data{s}(c,:)+(c-1)*plot_offset-min(steps{p}.extracted{s}(c,:)),'Color',colors{c},'LineWidth',1)
                ax = gca();
                ax.YLim = [-0.1*(max(max(steps{p}.extracted{s}(1:num_colors,:)))-min(min(steps{p}.extracted{s}(1:num_colors,:)))) (max(max(steps{p}.extracted{s}(1:num_colors,:)))-min(min(steps{p}.extracted{s}(1:num_colors,:))))*1.1];ax.XLabel.String = 'frame'; ax.YLabel.String = 'pixel';
                %ax.Visible = 'off';
                title(['p ' num2str(p) ',s ' num2str(s)]);
                % calculate correction for the line plots
                corr2 = mod(steps{p}.extracted_pos{s}(2,1),2)-1;
                if corr2 == 0
                    corr1 = mod(size(steps{p}.extracted_pos{s},2),2);
                else
                    corr1 = 0;
                end
                patch([steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,1):2:end+corr2-corr1)-0.5;...
                    steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,1)+1:2:end)-0.5;
                    steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,1)+1:2:end)-0.5;
                    steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,1):2:end+corr2-corr1)-0.5],...
                    [zeros(1,length(steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,1)+1:2:end)));...
                    zeros(1,length(steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,1)+1:2:end)));...
                    ones(1,length(steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,1)+1:2:end)))*ax.YLim(2);...
                    ones(1,length(steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,1)+1:2:end)))*ax.YLim(2)]...
                    ,colors{steps{p}.extracted_pos{s}(2,1)},'FaceAlpha',0.3,'EdgeColor','none')
                patch([steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,2):2:end-corr2*corr1-corr1-1)-0.5;...
                    steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,2)+1:2:end-corr1)-0.5;...
                    steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,2)+1:2:end-corr1)-0.5;...
                    steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,2):2:end-corr2*corr1-corr1-1)-0.5],...
                    [zeros(1,length(steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,2)+1:2:end-corr1)));...
                    zeros(1,length(steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,2)+1:2:end-corr1)));...
                    ones(1,length(steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,2)+1:2:end-corr1)))*ax.YLim(2);...
                    ones(1,length(steps{p}.extracted_pos{s}(1,steps{p}.extracted_pos{s}(2,2)+1:2:end-corr1)))*ax.YLim(2)],...
                    colors{steps{p}.extracted_pos{s}(2,2)},'FaceAlpha',0.3,'EdgeColor','none')
               end
           end
       end
       hold off
    end
end
%% FIGURE for dwell times - Coplot Group set
desktop.setGroupDocked(['Dwell times' folder]', 0);
pause(0.3)

if num_colors == 2

figH_dwell(1) = figure('Name',['Dwell ' domain_646],'NumberTitle','off');
   pause(0.1);  % Magic, reduces rendering errors
   set(get(handle(figH_dwell(1)), 'javaframe'), 'GroupName', ['Dwell times' folder]');
ax = axes;

h_hist2 = histogram(times2_1,'BinEdges',bin_edges,'EdgeColor',colors{1},'FaceColor',colors{1},'FaceAlpha',1,'LineWidth',3);
hold on
d = diff(h_hist2.BinEdges)/2;
BinCenters = h_hist2.BinEdges(1:end-1)+d; BinCenters = BinCenters(:);
[f2,goodness] = fit(BinCenters,h_hist2.Values(:),'exp1');
mu2 = abs(f2.b);
stderr = confint(f2); stderr = abs((stderr(1,2)-stderr(2,2))/2);
x = ax.XLim(1):0.1:ax.XLim(2);
y2 = f2(x);
%[mu2,stderr] = trunc_exp_fit(h_hist2.Data,bin_edges(1));
%y2 = exppdf(x,mu2);
%%%plot(x,y2,'LineWidth',3,'Color',text_color)
ax.Box = 'off'; %ax.XLabel.String = 'Dwell time [s]';
ax.XTick = 0:2:10; ax.TickDir = 'out'; ax.LineWidth = 1;
N2 = sum(h_hist2.Values);
text(0.5,0.9,sprintf('N = %d',N2),'Color',text_color,'Units','normalized')
%%%text(0.5,0.8,sprintf('exp1 \x03bb = %1.1f \x00b1 %1.1f,rsq %2.0f %% ',mu2,stderr,goodness.adjrsquare*100),'Color',text_color,'Units','normalized') %'FontWeight','bold'


% check what a second exponential fit would give for this data
exp2_fit = fittype(@(A,b,x) A/b^2*x.*exp(-x*b));
start = [sum(h_hist2.Values) 1];
[f_exp2,goodness] = fit(BinCenters(:),h_hist2.Values(:),exp2_fit,'Start',start);
stderr = confint(f_exp2); stderr = abs((stderr(1,2)-stderr(2,2))/2);
y_exp2 = f_exp2(x(x>cycle_time/2));
%%%plot(x(x>cycle_time/2),y_exp2,'.','Color',text_color)
%%%text(0.5,0.74,sprintf('exp2 \x03bb = %1.1f \x00b1 %1.1f,rsq %2.0f %%',f_exp2.b,stderr,goodness.adjrsquare*100),'Color',text_color,'Units','normalized')

% check what a double exp with different parameters gives for this data
%%%% START for double exponential fit
start_exp2 = [100 0.5 1];
xTrunc = 0.4;
exp2_ind_fit = @(pars,x) pars(1).*(exp(-pars(2)*x) - exp(-pars(3)*x));

weight_function = @(x) 1-1./(1+exp(-2*x+5)); % this one worked pretty nicely
weight_function = @(x) (1.2-1./(1+exp(-2*x+5)))/1.2;
%[mu, conf] = mle(data,'pdf',exp2_mle,'start',mle_start)


%%%%
mdl = NonLinearModel.fit(BinCenters(:),h_hist2.Values(:),exp2_ind_fit,start_exp2)%,'Weights',weight_function(BinCenters(:)))
fit_params = mdl.Coefficients.Estimate;
y_exp2_ind = exp2_ind_fit(fit_params,x(x>cycle_time/2));
plot(x(x>cycle_time/2),y_exp2_ind,'Color',text_color)
%text(0.5,0.68,sprintf('exp2_{ind} \x03bb = %1.1f %1.1f, rsq %2.0f %%, %2.2f',f_exp2_ind.b,f_exp2_ind.c,goodness.adjrsquare*100,stderr),'Color',text_color,'Units','normalized')

% Fit only the tails of the distributions
tails_trunc = 4;
bin_edges_tails = tails_trunc*cycle_time + (cycle_time*0.99):cycle_time:10;
x_tails = tails_trunc*cycle_time + (cycle_time*0.99):0.1:10;
start_tails = tails_trunc*cycle_time*2;
y_func_tails = @(x,mu) exppdf(x,mu)./(1-expcdf(tails_trunc*cycle_time,mu));

figH_dwell(2) = figure('Name',['Tail ' domain_646],'NumberTitle','off');
   pause(0.1);  % Magic, reduces rendering errors
   set(get(handle(figH_dwell(2)), 'javaframe'), 'GroupName', ['Dwell times' folder]');
ax3 = axes;
h_hist3 = histogram(times2_1,'BinEdges',bin_edges_tails,'EdgeColor',colors{1},'FaceColor',colors{1},'FaceAlpha',1,'LineWidth',3);
data_hist3 = times2_1(times2_1 >= tails_trunc*cycle_time);
bin_centers_tails = bin_edges_tails(1:end-1) + diff(bin_edges_tails)/2;
hold on
[mu, conf] = mle(data_hist3,'pdf',y_func_tails,'start',start_tails);
ft = fittype('a*exp(-x/mu)','problem','mu');
curve = fit(bin_centers_tails',h_hist3.Values',ft,'problem',mu,'start',length(data_hist3));
plot(x_tails,curve.a*exp(-x_tails/mu));

stderr = abs(conf(1)-conf(2))/2;
text(0.5,0.5,sprintf('\x03bb = %1.1f \x00b1 %1.3f',mu,stderr),'Color',text_color,'Units','normalized')
text(0.5,0.4,sprintf('N = %d',length(data_hist3)),'Color',text_color,'Units','normalized')
ax3.Box ='off'; ax3.TickDir = 'out'; ax3.LineWidth = 1;

mu
% % check what weibull fit would give for this data
% options = fitoptions('weibull');
% options.Lower = [2 2]
% options.StartPoint = [1 2]
% figure
% cdfplot(h_hist2.Data);
% [f_weib,goodness] = fit(BinCenters(:),h_hist2.Values(:)/sum(h_hist2.Values),'Weibull',options);
% y_weib = f_weib(x(x>cycle_time/2))*sum(h_hist2.Values);
% plot(x(x>cycle_time/2),y_weib,'.','Color',text_color)

hold off

pause(0.3)
% Second plot for second color
figH_dwell(3) = figure('Name',['Dwell ' domain_549],'NumberTitle','off'); % take this out
   pause(0.1);  % Magic, reduces rendering errors
   set(get(handle(figH_dwell(3)), 'javaframe'), 'GroupName', ['Dwell times' folder]'); 
ax2 = axes;
h_hist1 = histogram(times1_2,'BinEdges',bin_edges,'EdgeColor',colors{2},'FaceColor',colors{2},'FaceAlpha',1,'LineWidth',3);
hold on

[f1,goodness] = fit(BinCenters,h_hist1.Values(:),'exp1');
mu1 = abs(f1.b);
stderr = confint(f1); stderr = abs((stderr(1,2)-stderr(2,2))/2);
y1 = f1(x);
%[mu1,stderr] = trunc_exp_fit(h_hist1.Data,bin_edges(1));
%y1 = exppdf(x,mu1);
%%%plot(x,y1,'LineWidth',3,'Color',text_color)

N1 = sum(h_hist1.Values); 
h_hist1.FaceColor = 'none'; h_hist2.FaceColor = 'none';
ax2.Box = 'off';%ax2.XLabel.String = 'Dwell time [s]';
ax2.XTick = 0:2:10; ax2.TickDir = 'out'; ax2.LineWidth = 1;
%ax.XLabel.String = 'Dwell time [s]';
text(0.5,0.9,sprintf('N = %d',N1),'Color',text_color,'Units','normalized')
%%%text(0.5,0.8,sprintf('\x03bb = %1.1f \x00b1 %1.1f, %2.0f %%',mu1,stderr,goodness.adjrsquare*100),'Color',text_color,'Units','normalized')

% check what a second exponential fit would give for this data
start = [sum(h_hist1.Values) 1];
[f_exp2,goodness] = fit(BinCenters(:),h_hist1.Values(:),exp2_fit,'Start',start);
stderr = confint(f_exp2); stderr = abs((stderr(1,2)-stderr(2,2))/2);
y_exp2 = f_exp2(x(x>cycle_time/2));
%%%plot(x(x>cycle_time/2),y_exp2,'.','Color',text_color)
%%%text(0.5,0.74,sprintf('exp2 \x03bb = %1.1f \x00b1 %1.1f,rsq %2.0f %%',f_exp2.b,stderr,goodness.adjrsquare*100),'Color',text_color,'Units','normalized')


% check what a double exp with different parameters gives for this data
mdl = NonLinearModel.fit(BinCenters(:),h_hist1.Values(:),exp2_ind_fit,start_exp2)%,'Weights',weight_function(BinCenters(:)));
fit_params = mdl.Coefficients.Estimate;
y_exp2_ind = exp2_ind_fit(fit_params,x(x>cycle_time/2));
plot(x(x>cycle_time/2),y_exp2_ind,'Color',text_color)
%text(0.5,0.68,sprintf('exp2_{ind} \x03bb = %1.1f %1.1f, rsq %2.0f %%, %2.2f',f_exp2_ind.b,f_exp2_ind.c,goodness.adjrsquare*100,stderr),'Color',text_color,'Units','normalized')

hold off

data1 = h_hist1.Data(h_hist1.Data > 0.4);
data2 = h_hist2.Data(h_hist2.Data > 0.4);
[h,p] = ttest_runs(data1(data1 < 5), data2(data2 < 5),'data directly');
text(0.5,0.68,sprintf('h = %1.1f, p = %1.1f',h,p),'Color',text_color,'Units','normalized')

[h1,p1] = lillietest(data1,'Distribution','exponential','Alpha',0.3);
[h2,p2] = lillietest(data2,'Distribution','exponential','Alpha',0.3);
sprintf('lillie: h1 = %i, h2 = %i',h1,h2)
% plot the tail of this distribution only

figH_dwell(4) = figure('Name',['Tail ' domain_549],'NumberTitle','off');
   pause(0.1);  % Magic, reduces rendering errors
   set(get(handle(figH_dwell(4)), 'javaframe'), 'GroupName', ['Dwell times' folder]');
ax = axes;
h_hist4 = histogram(times1_2,'BinEdges',bin_edges_tails,'EdgeColor',colors{2},'FaceColor',colors{2},'FaceAlpha',1,'LineWidth',3);
data_hist4 = times1_2(times1_2 >= tails_trunc*cycle_time);
bin_centers_tails = bin_edges_tails(1:end-1) + diff(bin_edges_tails)/2;
hold on
[mu, conf] = mle(data_hist4,'pdf',y_func_tails,'start',start_tails);
ft = fittype('a*exp(-x/mu)','problem','mu');
curve = fit(bin_centers_tails',h_hist4.Values',ft,'problem',mu,'start',length(data_hist4));
plot(x_tails,curve.a*exp(-x_tails/mu));

stderr = abs(conf(1)-conf(2))/2;
text(0.5,0.5,sprintf('\x03bb = %1.1f \x00b1 %1.1f',mu,stderr),'Color',text_color,'Units','normalized')
text(0.5,0.4,sprintf('N = %d',length(data_hist4)),'Color',text_color,'Units','normalized')
ax.Box ='off';ax.TickDir = 'out'; ax.LineWidth = 1;
h_hist4.FaceColor = 'none'; h_hist3.FaceColor = 'none'; 
mu


% Change to 3d bar plot
figH_main(3) = figure('Name','Times Combined','NumberTitle','off');
   pause(0.1);  % Magic, reduces rendering errors
   set(get(handle(figH_main(3)), 'javaframe'), 'GroupName', ['Coplot' folder]');
ax3 = axes;
h_bar = bar3(BinCenters,[h_hist1.Values',h_hist2.Values'],1);
h_bar(1).FaceColor = colors{2};h_bar(1).EdgeColor = text_color;h_bar(1).EdgeAlpha = 0.4;
h_bar(2).FaceColor = colors{1};h_bar(2).EdgeColor = text_color;h_bar(2).EdgeAlpha = 0.4;
hold on
plot3(ones(length(x))*2,x,y2,'LineWidth',3,'Color',text_color)
plot3(ones(length(x))*1,x,y1,'LineWidth',3,'Color',text_color)
view(-74,9)
%legend({'11 to 20','20 to 11','fits'},'Location','northeast','FontSize',12,'TextColor',text_color)
%ax3.YLabel.String = 'Dwell time [s]';
ax3.XTick = []; 
ax3.YLim(1) = 0;


text(1,3.5,32,sprintf('\x03bb = %1.1f, N = %d',mu1,N1),'Color',colors{1},'FontWeight','bold')
text(1,3.5,27.5,sprintf('\x03bb = %1.1f, N = %d',mu2,N2),'Color',colors{2},'FontWeight','bold')
drawnow


end
%% FIGURE for step sizes
bin_edges = 1:2:33;
d = diff(bin_edges)/2;
BinCenters = bin_edges(1:end-1) + d; BinCenters = BinCenters(:);
figH_main(4) = figure('Name','Step Sizes','NumberTitle','off');
   pause(0.1);  % Magic, reduces rendering errors
   set(get(handle(figH_main(4)), 'javaframe'), 'GroupName', ['Coplot' folder]');
ax = axes;
hold on
for color = 1:num_colors
h_hist{color} = histogram(sizes_plot{color},'FaceColor',colors{color},'FaceAlpha',0.3,'BinEdges',bin_edges,'EdgeColor',colors{color},'LineWidth',2.5);
[f{color},goodness] = fit(BinCenters,h_hist{color}.Values(:),'gauss1');

x = ax.XLim(1):0.1:ax.XLim(2);
y{color} = f{color}(x);

h_fit = plot(x,y{color},'Color',text_color);
ax.Box = 'off';
text(0.75,0.5+0.08*(color-1),sprintf('%c = %1.1f, N = %d',956,f{color}.b1,sum(h_hist{color}.Values)),'Color',colors{color},'FontWeight','bold','Units','normalized');



end

hold off
legend([h_hist{1} h_hist{2} h_fit], {domain_646, domain_549, 'fits'},'FontSize',12,'TextColor',text_color);
ax.XLabel.String = 'Step size [nm]';

[h,p] = ttest2(sizes_plot{1},sizes_plot{2},'Vartype','unequal');
text(0.75,0.66,sprintf('p = %1.3f',p),'Color',text_color,'Units','normalized');


% h_bar = bar3(BinCenters,[h_hist3.Values',h_hist4.Values']);
% h_bar(1).FaceColor = colors{1};
% h_bar(2).FaceColor = colors{2};
% hold on
% view(-74,9)
%% FIGURE for step sizes sorted by previous
% after big steps
figH_main(5) = figure('Name','Step Sizes after big','NumberTitle','off');
   pause(0.1);  % Magic, reduces rendering errors
   set(get(handle(figH_main(5)), 'javaframe'), 'GroupName', ['Coplot' folder]');
ax = axes;
hold on
bin_edges = 0:2:26;


for color = 1:2
    h_hist{color} = histogram(after_big_steps_all{color}*93,'BinEdges',bin_edges,'FaceColor',colors{color},'FaceAlpha',0.3,'EdgeColor',colors{color},'LineWidth',2.5);
    BinCenters = h_hist{color}.BinEdges(1:end-1) + diff(h_hist{color}.BinEdges);
    [f{color},goodness] = fit(BinCenters(:),h_hist{color}.Values(:),'gauss1');
    x = ax.XLim(1):0.1:ax.XLim(2);
    y{color} = f{color}(x);
    plot(x,y{color},'Color',text_color)
    text(0.75,0.5+0.08*(color-1),sprintf('%c = %1.1f, N = %d',956,f{color}.b1,sum(h_hist{color}.Values)),'Color',colors{color},'Units','normalized');
end
legend({domain_646,'fits',domain_549},'TextColor',text_color,'Location','northwest','Box','off')
ax.Box = 'off';
hold off

[h,p] = ttest2(after_big_steps_all{1},after_big_steps_all{2},'Vartype','unequal');
text(0.75,0.66,sprintf('p = %1.3f',p),'Color',text_color,'Units','normalized');
ax.XLabel.String = 'Step size [nm]';

%after small steps
figH_main(6) = figure('Name','Step Sizes after small','NumberTitle','off');
   pause(0.1);  % Magic, reduces rendering errors
   set(get(handle(figH_main(6)), 'javaframe'), 'GroupName', ['Coplot' folder]');
ax = axes;
hold on
for color = 1:2
    h_hist{color} = histogram(after_small_steps_all{color}*93,'BinEdges',bin_edges,'FaceColor',colors{color},'FaceAlpha',0.3,'EdgeColor',colors{color},'LineWidth',2.5);
    BinCenters = h_hist{color}.BinEdges(1:end-1) + diff(h_hist{color}.BinEdges);
    [f{color},goodness] = fit(BinCenters(:),h_hist{color}.Values(:),'gauss1');
    x = ax.XLim(1):0.1:ax.XLim(2);
    y{color} = f{color}(x);
    plot(x,y{color},'Color',text_color)
    text(0.75,0.5+0.08*(color-1),sprintf('%c = %1.1f, N = %d',956,f{color}.b1,sum(h_hist{color}.Values)),'Color',colors{color},'Units','normalized');
end
legend({domain_646,'fits',domain_549},'TextColor',text_color,'Location','northwest','Box','off')
ax.Box = 'off';
ax.XLabel.String = 'Step size [nm]';
hold off
[h,p] = ttest2(after_small_steps_all{1},after_small_steps_all{2},'Vartype','unequal');
text(0.75,0.66,sprintf('p = %1.3f',p),'Color',text_color,'Units','normalized');
%% FIGURE for step directions
figH_main(7) = figure('Name','Step Directions','NumberTitle','off');
   pause(0.1);  % Magic, reduces rendering errors
   set(get(handle(figH_main(7)), 'javaframe'), 'GroupName', ['Coplot' folder]');
ax = polaraxes;

bin_edges_1 = (-80:5:80)/360*2*pi;
bin_edges_2 = (-85:5:85)/360*2*pi;
%polarhistogram(small_steps_dir_all{1}/360*2*pi,'EdgeColor',colors{1},'NumBins',60,'FaceColor','none')
hold on
polarhistogram(steps_dir_all{1}/360*2*pi,'EdgeColor',colors{1},'BinEdges',bin_edges_1,'FaceColor','none','LineWidth',2)
polarhistogram(steps_dir_all{2}/360*2*pi,'EdgeColor',colors{2},'BinEdges',bin_edges_2,'FaceColor','none','LineWidth',2)
%polarhistogram(small_steps_dir_all{2}/360*2*pi,'EdgeColor',colors{2},'NumBins',60,'FaceColor','none')
%polarhistogram(big_steps_dir_all{1}/360*2*pi,'EdgeColor',colors{1},'FaceColor',colors{1},'NumBins',60)
%polarhistogram(big_steps_dir_all{2}/360*2*pi,'EdgeColor',colors{2},'FaceColor',colors{2},'NumBins',60)
hold off
ax.ThetaTick = -80:20:80;
thetalim([-90 90])

%legend({['small ' domain_646], ['small ' domain_549], ['big ' domain_646], ['big ' domain_549]},'TextColor',text_color,'Location','southwest')
legend({domain_646, domain_549},'TextColor',text_color,'Location','southwest','Box','off')

ax.Box = 'off';
ax.ThetaZeroLocation = 'top';

[h,p] = ttest2(small_steps_dir_all{1},small_steps_dir_all{2},'Vartype','unequal');
%text(0.75,1.06,sprintf('small: p = %1.3f',p),'Color',text_color,'Units','normalized');
[h,p] = ttest2(big_steps_dir_all{1},big_steps_dir_all{2},'Vartype','unequal');
%text(0.75,0.98,sprintf('big: p = %1.3f',p),'Color',text_color,'Units','normalized');


drawnow
%% FIGURE for the combined step size plot
bin_edges = 1:2:33;
d = diff(bin_edges)/2;
BinCenters = bin_edges(1:end-1) + d; BinCenters = BinCenters(:);
figH_main(8) = figure('Name','Sizes Combined','NumberTitle','off');
   pause(0.1);  % Magic, reduces rendering errors
   set(get(handle(figH_main(8)), 'javaframe'), 'GroupName', ['Coplot' folder]');
ax = axes;
hold on

h_hist5 = histogram(all_sizes ,'FaceColor','none','BinEdges',bin_edges,'EdgeColor',text_color,'LineWidth',2);
[f5,goodness] = fit(BinCenters,h_hist5.Values(:),'gauss1');
x = ax.XLim(1):0.1:ax.XLim(2);
y5 = f5(x);

plot(x,y5,'Color',text_color)
ax.Box = 'off';
ax.XTick = 0:4:32;



hold off

ax.XLabel.String = 'Step size [nm]';
text(ax.XLim(1) + abs(diff(ax.XLim))*0.8,ax.YLim(1) + abs(diff(ax.YLim))*0.64,sprintf('%c = %1.1f',956,f5.b1),'FontWeight','bold','Color',text_color)
text(ax.XLim(1) + abs(diff(ax.XLim))*0.8,ax.YLim(1) + abs(diff(ax.YLim))*0.57,sprintf('c = %1.1f',f5.c1),'FontWeight','bold','Color',text_color)
text(ax.XLim(1) + abs(diff(ax.XLim))*0.8,ax.YLim(1) + abs(diff(ax.YLim))*0.5,sprintf('N = %d',sum(h_hist5.Values)),'FontWeight','bold','Color',text_color)

ax.TickDir = 'out'; ax.LineWidth = 1;
%bin_edges = adjust_histogram([sizes_1 sizes_2]);
%speed_hist_fit('dummy',[sizes_1 sizes_2],bin_edges)

%% plot it
% figure
% for i = 1:numel(names)
%     data = open([folder names{i} '/data.mat']);
%     data = data.data;
%     run = data.runs{1,1};
%     steps_plot = clean_up_steps(data.steps.detected);
%     step_plot = plot(steps_plot,'lineWidth',3);
%     hold on
%     step_orig_plot = plot(data.steps.detected,'LineWidth',0.5);%plot(run(6,:));
%     run_plot = plot(run(6,:));
%     
%     % Color plots according to folder
%     if mod(i,num_colors) == 0
%         step_plot.Color = [86,143,205]/255; run_plot.Color = [86,143,205]/255; step_orig_plot.Color = [86,143,205]/255;
%     elseif mod(i,num_colors) == 1
%         step_plot.Color = [123,163,82]/255; run_plot.Color = [123,163,82]/255; step_orig_plot.Color = [123,163,82]/255;
%     elseif mod(i,num_colors) == 2
%         step_plot.Color = [202,104,77]/255; run_plot.Color = [202,104,77]/255; step_orig_plot.Color = [202,104,77]/255;
%     end
%     
%     if mod(i,num_colors) == 0 && i < numel(names); figure; end
% end
% hold off





set_pdf_sizes

%% Write out relevant Data
fprintf('Mean step dwell times: \n')
fprintf([domain_646 ': '  num2str(round(mean(h_hist2.Data(h_hist2.Data > 0))*100)/100) '\n'])
fprintf([domain_549 ': '  num2str(round(mean(h_hist1.Data(h_hist1.Data > 0))*100)/100) '\n'])

backstep_freq = pool_data_cell_struct(steps,'backstep_freq');
backstep_freq = mean(backstep_freq,2);
fprintf('Backstepping frequency: \n')
fprintf([domain_646 ': ' num2str(round(backstep_freq(1)*100)) '\n'])
fprintf([domain_549 ': ' num2str(round(backstep_freq(2)*100)) '\n'])

%% Default Figure properties
%reset plot properties
myDim   = java.awt.Dimension(3, 2); % comluns, rows
desktop.setDocumentArrangement(['Coplot' folder]', 2, myDim)
% 1: Maximized, 2: Tiled, 3: Floating
myDim   = java.awt.Dimension(2, 2); % comluns, rows
desktop.setDocumentArrangement(['Dwell times' folder]', 2, myDim)

pause(0.5)
set_pdf_sizes
warning(bakWarn);

set(groot,'defaultFigureColor','default');
set(groot,'defaultFigureWindowStyle','default');
set(groot,'defaultAxesColor','default');
set(groot,'defaultAxesXColor','default');set(groot,'defaultAxesYColor','default');set(groot,'defaultAxesZColor','default');
set(groot,'defaultAxesColorOrder','default');set(groot,'defaultLineLineWidth','default');
set(groot,'defaultFigureInvertHardcopy','off');set(groot,'defaultAxesFontSize','default');set(groot,'defaultTextFontSize','default');



end

function steps = clean_up_steps(steps)
% extract steps with only one or two positions
%compare value of step before and after and discard step, if step < 6nm
step_size_threshold = 6/94; %px


for i = 2:length(steps)-2  
   % detect peaks with width 2 or 1 up
   if steps(i) > steps(i-1) && steps(i+2) < steps(i)
       steps(i:i+1) = steps(i+2)*ones(2,1);
       %detect steps that are to small after peak detection
       if abs(steps(i) - steps(i-1)) < step_size_threshold
           steps(steps == steps(i)) = steps(i-1);
       end
   end
   
   %detect peaks down width 1 or 2
   if steps(i) < steps(i-1) && steps(i+2) > steps(i)
       steps(i:i+1) = steps(i-1)*ones(2,1);
   end
end
end

function positions = get_step_positions(steps,l)

positions = [];
for i = 2:numel(steps)
    if steps(i) ~= steps(i-1) %% was ~= 
        positions(1,end+1) = i;
        positions(2,end) = l;
        positions(3,end) = steps(i)-steps(i-1);
    end
end

end

function sizes = get_step_sizes(steps)

sizes = diff(steps);
sizes = sizes(sizes ~= 0);

end

function [mu,stderr] = trunc_exp_fit(data,xTrunc)
    data = data(data > xTrunc);
    start = mean(data);
    y_func = @(x,mu) exppdf(x,mu)./(1-expcdf(xTrunc,mu));

    [mu, conf] = mle(data,'pdf',y_func,'start',start);
    stderr = abs((conf(1)-conf(2))/2);
    
end


%% Old version of trying to detectalternating steps. Did not work because it
% was not suitable for example 3 consecutive steps of one head.
% for k = 1:numel(steps)
%     segment = 1;
%     pos_start = 1;
%     pos_start_m = 1;
%     sign_old = 1;
%     for m = 1:numel(steps{k}.positions{1})
%         if m <= numel(steps{k}.positions{2})
%             %Check which step occurs first
%             sign_new = sign(steps{k}.positions{1}(m)-steps{k}.positions{2}(m));
%             %ignor if steps occur at the same moment
%             if sign_new == 0; sign_new = sign_old; end
%             %check if a step occured out of alternation
%             pos_end = steps{k}.positions{1}(m);
%             if sign_new == -sign_old
%                 if m > pos_start_m +2
%                    steps{k}.extracted_pos{segment} = [pos_start pos_end];
%                    steps{k}.extracted{segment} = [steps{k}.detected{1}(pos_start:pos_end);steps{k}.detected{2}(pos_start:pos_end)];
%                    segment = segment + 1;
%                 end
%                pos_start = pos_end;
%                pos_start_m = m;
%             end
%         end
%     end
% end